#include "defines.h"
#include "register.h"
#include "serial.h"

enum {
	INDEX_UART_0,
	INDEX_UART_1,
	INDEX_UART_2,
	INDEX_UART_NUM
};

/* ǥХ */
int serial_init(int index)
{
  if (index < 0 || index >= INDEX_UART_NUM) {
    return 1;
  }

  switch (index) {
  case INDEX_UART_0:
    V850ES_JG2_UA0CTL0 = 0x00;
    V850ES_JG2_PMC3 = 0x0003;
    V850ES_JG2_PFC3 = 0x0000;
    V850ES_JG2_UA0CTL0 = 0x12;
    V850ES_JG2_UA0OPT = 0x14;
    V850ES_JG2_UA0CTL1 = 0x03;
    V850ES_JG2_UA0CTL2 = 0x82;
    V850ES_JG2_UA0CTL0 = 0x92;
    break;

  case INDEX_UART_1:
    V850ES_JG2_UA1CTL0 = 0x00;
    V850ES_JG2_PMC9 = 0x0003;
    V850ES_JG2_PFCE9 = 0x0003;
    V850ES_JG2_PFC9 = 0x0000;
    V850ES_JG2_UA1CTL0 = 0x12;
    V850ES_JG2_UA1OPT = 0x14;
    V850ES_JG2_UA1CTL1 = 0x03;
    V850ES_JG2_UA1CTL2 = 0x82;
    V850ES_JG2_UA1CTL0 = 0x92;
    break;

  case INDEX_UART_2:
    V850ES_JG2_UA2CTL0 = 0x00;
    V850ES_JG2_PMC3 = 0x0300;
    V850ES_JG2_PFC3 = 0x0000;
    V850ES_JG2_UA2CTL0 = 0x12;
    V850ES_JG2_UA2OPT = 0x14;
    V850ES_JG2_UA2CTL1 = 0x03;
    V850ES_JG2_UA2CTL2 = 0x82;
    V850ES_JG2_UA2CTL0 = 0x92;
    break;
  }

  return 0;
}

/* ǽ */
int serial_is_send_enable(int index)
{
  if (index < 0 || index >= INDEX_UART_NUM) {
    return 1;
  }

  switch (index) {
  case INDEX_UART_0:
    return (!(V850ES_JG2_UA0STR & 0x80));
    break;

  case INDEX_UART_1:
    return (!(V850ES_JG2_UA1STR & 0x80));
    break;

  case INDEX_UART_2:
    return (!(V850ES_JG2_UA2STR & 0x80));
    break;
  }

  return 1;
}

/* ʸ */
int serial_send_byte(int index, unsigned char c)
{
  if (index < 0 || index >= INDEX_UART_NUM) {
    return 1;
  }

  /* ǽˤʤޤԤ */
  while (!serial_is_send_enable(index)) {
    ;
  }

  switch (index) {
  case INDEX_UART_0:
    V850ES_JG2_UA0CTL0 |= 0x40;
    V850ES_JG2_UA0TX = c;
    V850ES_JG2_UA0STR &= 0x7F;
   break;
  case INDEX_UART_1:
    V850ES_JG2_UA1CTL0 |= 0x40;
    V850ES_JG2_UA1TX = c;
    V850ES_JG2_UA1STR &= 0x7F;
    break;
  case INDEX_UART_2:
    V850ES_JG2_UA2CTL0 |= 0x40;
    V850ES_JG2_UA2TX = c;
    V850ES_JG2_UA2STR &= 0x7F;
    break;
  }

  return 0;
}
